#include <graph/plugins/http/http.h>
#include <graph/plugins/plugin.h>
#include <rum/http/response.h>
#include <rum/http/server.h>
#include <rum/http/uri.h>
#include <rum/tcp/error.h>
// #include <flags-cpp/flags-cpp.h>
#include <iostream>
#include <sstream>

using namespace Rum::HTTP;
// using namespace Flags;

Server* server;

extern "C" {
plugin_t plugin = {.version = 1, .run_method = &run, .destroy_method = &destroy};

int run() {
  // Parser parser;
  // int* port = parser.add<int>("port", "http port", false, 8080);
  // int* workers = parser.add<int>("workers", "number of worker threads", false, 10);

  // bool* help = parser.add<bool>("help", "print help", false, false);

  // if (!parser.parse(plugin.argc, plugin.argv) || *help) {
  //   parser.help();
  // }

  // server = new Server(*port, *workers, DEFAULT_BUFFER_SIZE);
  try {
    server = new Server(8080, 10, DEFAULT_BUFFER_SIZE);
    server->add_path<GET>("/add", [](const Request& req, Response& resp) {
      URI uri = req.copy_uri();

      auto params = uri.get_parameters();

      int chart = 0;
      if (params.contains("chart"))
        chart = std::stoi(params.at("chart"));

      std::string series = "1st";
      if (params.contains("series"))
        series = params.at("series");

      if (params.contains("x") && params.contains("y")) {
        point_t point;

        point.x = std::stod(params.at("x"));
        point.y = std::stod(params.at("y"));
        plugin.update_callback(chart, series.c_str(), &point, 1);
      }
    });

    std::cout << "starting http server" << std::endl;
    server->listen();

    return 0;
  } catch (Rum::TCP::Error e) {
    std::cerr << e.what() << std::endl;
    delete server;
    return 1;
  }
}

int destroy() {
  if (server)
    server->end();
  std::cout << "stopped http server" << std::endl;
  return 0;
}
}